/* ----------------------------------------------------------------------- *
 *   Copyright 1996-2004 Angel Marin - All Rights Reserved
 *   Angel Marin - anmar@gmx.net - http://anmar.eu.org/
 * 
 *   This file is part of rrdNetStats.
 *
 *   rrdNetStats is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   rrdNetStats is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with rrdNetStats; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * ----------------------------------------------------------------------- */
/*
  File autogenerated by gengetopt version 2.11
  generated with the following command:
  ..\..\Utils\gengetopt\bin\gengetopt.exe --input=CTNrrdNetStats.ggo --file-name=cmdline 

  The developers of gengetopt consider the fixed text that goes in all
  gengetopt output files to be in the public domain:
  we make no copyright claims on it.
*/

#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "getopt.h"

#include "cmdline.h"

void
cmdline_parser_print_version (void)
{
  printf ("%s %s\n", CMDLINE_PARSER_PACKAGE, CMDLINE_PARSER_VERSION);
}

void
cmdline_parser_print_help (void)
{
  cmdline_parser_print_version ();
  printf("\n"
  "Purpose:\n"
  "  CTNrrdNetStats is a win32 command line utility that retrieves\n"
  "  network interface statistics and feeds then into a Round Robin\n"
  "  Database using RRDtool\n"
  "\n"
  "Usage: %s [OPTIONS]...\n", CMDLINE_PARSER_PACKAGE);
  printf("\n");
  printf("  -h, --help                  Print help and exit\n");
  printf("  -V, --version               Print version and exit\n");
  printf("\nOptions:\n");
  printf("  -b, --background            Run in the background\n");
  printf("  -d, --database=filepath     Path to database file  (default=`eth0.rrd')\n");
  printf("  -i, --path-img=path         Path to output image files  (default=`.')\n");
  printf("  -t, --path-rrdtool=STRING   Deprecated option (input ignored)\n");
  printf("\n");
  printf(" Group: Action - Choose what action to perform\n");
  printf("  -l, --list                  List interfaces\n");
  printf("  -g, --graph=basename        Generates graphic files  (default=`eth0')\n");
  printf("  -u, --update=interface      Updates the database\n");
  printf("  -c, --create=database path  Creates the database  (default=`eth0.rrd')\n");
}


static char *gengetopt_strdup (const char *s);

/* gengetopt_strdup() */
/* strdup.c replacement of strdup, which is not standard */
char *
gengetopt_strdup (const char *s)
{
  char *result = (char*)malloc(strlen(s) + 1);
  if (result == (char*)0)
    return (char*)0;
  strcpy(result, s);
  return result;
}

int
cmdline_parser (int argc, char * const *argv, struct gengetopt_args_info *args_info)
{
  int c;	/* Character of the parsed option.  */
  int missing_required_options = 0;
  int Action_group_counter = 0;
  

  args_info->help_given = 0 ;
  args_info->version_given = 0 ;
  args_info->background_given = 0 ;
  args_info->database_given = 0 ;
  args_info->path_img_given = 0 ;
  args_info->path_rrdtool_given = 0 ;
  args_info->list_given = 0 ;
  args_info->graph_given = 0 ;
  args_info->update_given = 0 ;
  args_info->create_given = 0 ;
#define clear_args() { \
  args_info->database_arg = gengetopt_strdup("eth0.rrd") ;\
  args_info->path_img_arg = gengetopt_strdup(".") ;\
  args_info->path_rrdtool_arg = NULL; \
  args_info->graph_arg = gengetopt_strdup("eth0") ;\
  args_info->create_arg = gengetopt_strdup("eth0.rrd") ;\
}

  clear_args();

  optarg = 0;
  optind = 1;
  opterr = 1;
  optopt = '?';

  while (1)
    {
      int option_index = 0;
      char *stop_char;

      static struct option long_options[] = {
        { "help",	0, NULL, 'h' },
        { "version",	0, NULL, 'V' },
        { "background",	0, NULL, 'b' },
        { "database",	1, NULL, 'd' },
        { "path-img",	1, NULL, 'i' },
        { "path-rrdtool",	1, NULL, 't' },
        { "list",	0, NULL, 'l' },
        { "graph",	1, NULL, 'g' },
        { "update",	1, NULL, 'u' },
        { "create",	1, NULL, 'c' },
        { NULL,	0, NULL, 0 }
      };

      stop_char = 0;
      c = getopt_long (argc, argv, "hVbd:i:t:lg:u:c:", long_options, &option_index);

      if (c == -1) break;	/* Exit from `while (1)' loop.  */

      switch (c)
        {
        case 'h':	/* Print help and exit.  */
          clear_args ();
          cmdline_parser_print_help ();
          exit (EXIT_SUCCESS);

        case 'V':	/* Print version and exit.  */
          clear_args ();
          cmdline_parser_print_version ();
          exit (EXIT_SUCCESS);

        case 'b':	/* Run in the background.  */
          if (args_info->background_given)
            {
              fprintf (stderr, "%s: `--background' (`-b') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->background_given = 1;
          break;

        case 'd':	/* Path to database file.  */
          if (args_info->database_given)
            {
              fprintf (stderr, "%s: `--database' (`-d') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->database_given = 1;
          if (args_info->database_arg)
            free (args_info->database_arg); /* free default string */
          args_info->database_arg = gengetopt_strdup (optarg);
          break;

        case 'i':	/* Path to output image files.  */
          if (args_info->path_img_given)
            {
              fprintf (stderr, "%s: `--path-img' (`-i') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->path_img_given = 1;
          if (args_info->path_img_arg)
            free (args_info->path_img_arg); /* free default string */
          args_info->path_img_arg = gengetopt_strdup (optarg);
          break;

        case 't':	/* Deprecated option (input ignored).  */
          if (args_info->path_rrdtool_given)
            {
              fprintf (stderr, "%s: `--path-rrdtool' (`-t') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->path_rrdtool_given = 1;
          args_info->path_rrdtool_arg = gengetopt_strdup (optarg);
          break;

        case 'l':	/* List interfaces.  */
          if (args_info->list_given)
            {
              fprintf (stderr, "%s: `--list' (`-l') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->list_given = 1;
          Action_group_counter += 1;
        break;

        case 'g':	/* Generates graphic files.  */
          if (args_info->graph_given)
            {
              fprintf (stderr, "%s: `--graph' (`-g') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->graph_given = 1;
          Action_group_counter += 1;
        if (args_info->graph_arg)
            free (args_info->graph_arg); /* free default string */
          args_info->graph_arg = gengetopt_strdup (optarg);
          break;

        case 'u':	/* Updates the database.  */
          if (args_info->update_given)
            {
              fprintf (stderr, "%s: `--update' (`-u') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->update_given = 1;
          Action_group_counter += 1;
        args_info->update_arg = strtol (optarg,&stop_char,0);
          break;

        case 'c':	/* Creates the database.  */
          if (args_info->create_given)
            {
              fprintf (stderr, "%s: `--create' (`-c') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->create_given = 1;
          Action_group_counter += 1;
        if (args_info->create_arg)
            free (args_info->create_arg); /* free default string */
          args_info->create_arg = gengetopt_strdup (optarg);
          break;


        case 0:	/* Long option with no short option */

        case '?':	/* Invalid option.  */
          /* `getopt_long' already printed an error message.  */
          exit (EXIT_FAILURE);

        default:	/* bug: option not considered.  */
          fprintf (stderr, "%s: option unknown: %c\n", CMDLINE_PARSER_PACKAGE, c);
          abort ();
        } /* switch */
    } /* while */

  if ( Action_group_counter != 1)
    {
      fprintf (stderr, "%s: %d options of group Action were given. One is required\n\n", CMDLINE_PARSER_PACKAGE, Action_group_counter);
	  cmdline_parser_print_help ();
      missing_required_options = 1;
    }
  

  if ( missing_required_options )
    exit (EXIT_FAILURE);

  return 0;
}
